(function() {
  var html = document.querySelector('html').cloneNode(true),
      attrlist = [
          'type',
          'id',
          'align',
          'autoplay',
          'xmlns',
          'name',
          'content',
          'target',
          'width',
          'height',
          'charset',
          'http-equiv',
          'rel',
          'xml:lang'
      ];

  (function (dom) {
    var len = dom.childNodes.length;
    if (len === 0) {
      return;
    }
    for (var i = 0; i < len; ++i) {
      var thisNode = dom.childNodes[i];
      switch (thisNode.nodeType) {
        case Node.COMMENT_NODE:
        case Node.TEXT_NODE:
          dom.childNodes[i].remove();
          --i;
          --len;
          break;
        default:
          var attrs = thisNode.attributes,
              attrsLen = attrs.length;
          for (var j = 0; j < attrsLen; ++j) {
            var attr = attrs[j];
            if (attrlist.indexOf(attr.name) === -1) {
              attr.value = '';
            }
          }
          arguments.callee(dom.childNodes[i]);
      }
    }
  }(html));

  return html.outerHTML;
}());
